; WinDrag, v.2006-06-21 (init: 2004-11-22)
; draft!
; http://www.geocities.com/xmemor/2lz/tinyasm.hrml

.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib  user32
inclib  kernel32
inclib  gdi32
inclib  shell32
inclib  comctl32

.const
idm_about   equ 0EEE0h

.data
_about2			db "WinDrag  (draft  v.2006-06-21)",13,10,13,10
            db "0)",13,10
            db "  Cursor over checkbox more than 2 sec  -> switch on",13,10,13,10
						db "1)",13,10
						db "  Pos /Size :  drag  Left /Right  mouse",13,10
						db "  Z-ord  Up / Down :  mouse Wheel  or  Left /Right  2-click",13,10
						db "  Parent = Progman /Prior /0 :  F5 /F6 /F7 key + Left  2-click",13,10
						db "  Click :  CTRL key + Left click",13,10
						db "  Close :  ESC key + Left click",13,10
						db "  on/off  SS_CENTERIMAGE :  SHIFT key + Left click",13,10,13,10
						db "2) <WindowRgn>",13,10
						db "  Color-2-Hole /Cancel all holes :  Right /Left  2-click",13,10
						db "  Pen-2-Hole :  Drag  Left  mouse",13,10,13,10
						db "3)",13,10
						db "  Pen :  Drag  Left  mouse",13,10
						db "  ColorPicker /Snapshot :  Right /Left  2-click",13,10
						db "  Snapshot + Bmp-file :  CTRL key + Left  2-click",13,10,13,10
						db "Choose  Root Parent :  + ALT key",13,10,13,10
						db "Resized  WinDrag  background :  Left  2-click",13,10,13,10
						db "z-order  current  value",13,10
						db "  z :  #x /#y /#z",13,10
						db "  Root Parent (top-level) / child / desktop child",13,10,13,10
						db "WinDrag  &  other tiny asm apps+sources   by kero:",13,10
						db "http://www.geocities.com/xmemor/2lz/tinyasm.html",0
_about			db " About + Help",0
DlgName     db "Dlg",0
_static			db "static",0
_btntext		db "Mouse:",13,10
            db "Left &&",13,10
            db "Right",0
frmt				db "     rgb: %8.8lX    %sREGION",13,10
            db " hw: %8.8lX    id: %8.8lX /%lu    z: %lu /%lu /%lu",13,10
            db " sc.( %d , %d ) / cl.( %d , %d ) ,   %d * %d",13,10
            db " ""%s""",13,10
            db " ""%s""",0
frmt2       db "snap_%10.10lu.bmp",0
color3000		dd 00c4ffffh
_none       db "NONE ",0
_null       db "NULL",0
_simple     db "SIMPLE",0
_complex    db "COMPLEX",0
;szNoDC     db "Couldn''t create device context.",0
szNoDC      db "Couldn''t get device context.",0
szNoMemDC   db "Couldn''t create compatible device context.",0
szNoBMP     db "Couldn''t create compatible bitmap.",0
szNoObj     db "Couldn''t select bitmap.",0
szNoCopy    db "Couldn''t copy bitmap.",0
szNoFile    db "Couldn''t write file to disk.",0
;szDone     db "Bitmap captured to disk file.",0
_cursor			db "WD_cursor",0
;_32770      db "#32770",0
;_frame			db "WD_frame",0
_Progman		db "Progman",0
_snap				db "WD_snapshot",0
_z          db 0

.data?
hinst				HINSTANCE ?
hdlg				HWND ?
hw0					HWND ?
hw2000			HWND ?
hw2001			HWND ?
hw2002			HWND ?
hw2003			HWND ?
hw3000			HWND ?
hw4000			HWND ?
hw4001			HWND ?
hw_old			HWND ?
hwt					HWND ?
hwta				HWND ?
hwtr				HWND ?
hwp					HWND ?
hwpa				HWND ?
hwpr				HWND ?
hbr3000			HBRUSH ?
hbr   			HBRUSH ?
hpen        HPEN ?
hppen       HPEN ?
hdc         HDC ?
hr1					HRGN ?
hr2					HRGN ?
status			dd ?
d_x					dd ?
d_y					dd ?
d_x2				dd ?
d_y2				dd ?
hcur_custom	dd ?
hcur_sys		dd ?
hmenu				dd ?
OldProc			dd ?
lpproc      dd ?
color       dd ?
buff				db 1024+1 dup(?)
nw					dd ?
ntw					dd ?
ncw					dd ?
capt				dd ?
;old32770		dd ?
;hbrframe		HBRUSH ?
;hframe			HWND ?
;hrgnframe	HRGN ?
hbrbg       HBRUSH ?
hProgman		HWND ?
hBtmp 			dd ?
oldproc			dd ?
timercount  dd ?

.code

;################################################################################################

NewProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local buf[MAX_PATH+1]:BYTE
	mov eax,uMsg
	.if eax==WM_LBUTTONDBLCLK
		invoke ShowWindow,hWnd,SW_HIDE
	.elseif eax==WM_CLOSE
	.elseif	eax==WM_DROPFILES
		invoke DragQueryFile,wParam,0,addr buf,MAX_PATH
		invoke DragFinish,wParam
		invoke LoadImage,0,addr buf,IMAGE_BITMAP,0,0,LR_LOADFROMFILE
		.if eax!=0
			push eax
			invoke DeleteObject,hBtmp
			pop hBtmp
			invoke SendMessage,hw4001,STM_SETIMAGE,IMAGE_BITMAP,hBtmp
		.endif
	.elseif eax==WM_LBUTTONDOWN
		invoke DefWindowProc,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam
	.else
		invoke CallWindowProc,oldproc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
NewProc  endp

;################################################################################################

LoadBitmapBG proc uses edi esi hWnd:HWND,hInst:HINSTANCE,lpFileName:LPSTR,fuLoad:DWORD,SizeFlag:BOOL
	local hBmp:HBITMAP
	local hbrsh:DWORD
	local rt:RECT

	xor eax,eax
	mov hbrsh,eax
	mov edi,eax
	mov esi,eax
	mov eax,SizeFlag
	test eax,eax
	jz @f
	invoke GetClientRect,hWnd,addr rt
	mov edi,rt.right
	mov esi,rt.bottom
@@:
	invoke LoadImage,hInst,lpFileName,IMAGE_BITMAP,edi,esi,fuLoad
	test eax,eax
	jz @1
	mov hBmp,eax
	invoke CreatePatternBrush,eax
	test eax,eax
	jz @f
	mov hbrsh,eax
	invoke SetClassLong,hWnd,GCL_HBRBACKGROUND,eax
@@:
	invoke DeleteObject,hBmp
@1:
	mov eax,hbrsh
	ret
LoadBitmapBG endp

;################################################################################################

CapWindow proc uses ebx edi hWnd:HWND,lpFileName:DWORD

	local rect							:RECT
 	local hDc								:HDC
	local dwWidth						:DWORD
	local dwHeight					:DWORD
  local dwBPP							:DWORD
  local dwNumColors				:DWORD
  local memdc							:HDC
  local bitmapinfoheader	:BITMAPINFOHEADER
  local bmpinfo						:BITMAPINFO
  local pBits							:DWORD
  local hBitmap						:HBITMAP
  local colors[256]				:RGBQUAD
  local bitmapfileheader	:BITMAPFILEHEADER
  local ColorSize					:DWORD
  local hFile							:HANDLE
  local dwBytes						:DWORD

	xor ebx,ebx

	invoke GetWindowDC,hWnd
;	invoke GetDC,0

	mov edi,offset szNoDC
	test eax,eax
	jz ExitFunc
	mov hDc,eax
	
	invoke GetWindowRect,hWnd,addr rect
	mov eax,rect.left
	mov eax,rect.top
	mov eax,rect.right
	sub eax,rect.left
	mov dwWidth,eax
	mov eax,rect.bottom
	sub eax,rect.top
	mov dwHeight,eax

  invoke GetDeviceCaps,hDc,BITSPIXEL
  mov dwBPP,eax
  mov dwNumColors,ebx
	cmp eax,8
	ja @f
	invoke GetDeviceCaps,hDc,NUMCOLORS
	mov dwNumColors,eax
@@:
  invoke CreateCompatibleDC,hDc
	mov edi,offset szNoMemDC
	test eax,eax
	jz ExitFunc2
  mov memdc,eax

  mov bmpinfo.bmiHeader.biSize,sizeof BITMAPINFOHEADER
  mov eax,dwWidth
  mov bmpinfo.bmiHeader.biWidth,eax
  mov eax,dwHeight
  mov bmpinfo.bmiHeader.biHeight,eax
  mov bmpinfo.bmiHeader.biPlanes,1
  mov ax,word ptr [dwBPP]
  mov bmpinfo.bmiHeader.biBitCount,ax
  mov bmpinfo.bmiHeader.biCompression,BI_RGB
  mov bmpinfo.bmiHeader.biSizeImage,ebx
  mov bmpinfo.bmiHeader.biXPelsPerMeter,ebx
  mov bmpinfo.bmiHeader.biYPelsPerMeter,ebx
  mov eax,dwNumColors
  mov bmpinfo.bmiHeader.biClrUsed,eax
  mov bmpinfo.bmiHeader.biClrImportant,eax
 
  invoke CreateDIBSection,hDc,addr bmpinfo,DIB_PAL_COLORS,addr pBits,ebx,ebx
	mov edi,offset szNoBMP
	test eax,eax
	jz ExitFunc3
  mov hBitmap,eax

  invoke SelectObject, memdc, hBitmap
	mov edi,offset szNoObj
  .if (eax==NULL) || (eax==GDI_ERROR)
      jmp ExitFunc3
  .endif
;;test eax,eax
;;jz @f
;;cmp eax,GDI_ERROR
;;@@:
;;jz ExitFunc3

  invoke BitBlt,memdc,ebx,ebx,dwWidth,dwHeight,hDc,ebx,ebx,SRCCOPY or CAPTUREBLT   ; instead of just (SRCCOPY
; invoke BitBlt,memdc,ebx,ebx,dwWidth,dwHeight,hDc,rect.left,rect.top,SRCCOPY or CAPTUREBLT

	mov edi,offset szNoCopy
	test eax,eax
	jz ExitFunc3

  mov eax,dwNumColors
	test eax,eax
	jz @f
	invoke GetDIBColorTable,memdc,ebx,dwNumColors,addr colors
	mov dwNumColors,eax
@@:
  mov bitmapfileheader.bfType,4D42h
  mov eax,dwNumColors
  xor edx,edx
  mov ecx,sizeof RGBQUAD
  mul ecx
  mov ColorSize,eax
  mov eax,dwWidth
  xor edx,edx
  mov ecx,dwHeight
  mul ecx
  xor edx,edx
  mov ecx,dwBPP
  mul ecx
  shr eax,3
  add eax,ColorSize
  add eax,sizeof BITMAPFILEHEADER
  add eax,sizeof BITMAPINFOHEADER
  mov bitmapfileheader.bfSize,eax
  mov bitmapfileheader.bfReserved1,bx
  mov bitmapfileheader.bfReserved2,bx
  mov eax,ColorSize
  add eax,sizeof BITMAPFILEHEADER
  add eax,sizeof BITMAPINFOHEADER
  mov bitmapfileheader.bfOffBits,eax
  mov bitmapinfoheader.biSize,sizeof BITMAPINFOHEADER
  mov eax,dwWidth
  mov bitmapinfoheader.biWidth,eax
  mov eax,dwHeight
  mov bitmapinfoheader.biHeight,eax
  mov bitmapinfoheader.biPlanes,1
  mov ax,word ptr [dwBPP]
  mov bitmapinfoheader.biBitCount,ax
  mov bitmapinfoheader.biCompression,BI_RGB
  mov bitmapinfoheader.biSizeImage,ebx
  mov bitmapinfoheader.biXPelsPerMeter,ebx
  mov bitmapinfoheader.biYPelsPerMeter,ebx
  mov eax,dwNumColors
  mov bitmapinfoheader.biClrUsed,eax
  mov bitmapinfoheader.biClrImportant,ebx

	.if lpFileName==0
  	invoke DeleteDC,memdc
		invoke ReleaseDC,hWnd,hDc
		mov eax,hBitmap
	  ret
	.endif

  invoke CreateFile,lpFileName,GENERIC_WRITE,ebx,ebx,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,ebx
	mov edi,offset szNoFile
	cmp eax,INVALID_HANDLE_VALUE
	jz ExitFunc4
  mov hFile,eax

  invoke WriteFile,hFile,addr bitmapfileheader,sizeof BITMAPFILEHEADER,addr dwBytes,ebx
  invoke WriteFile,hFile,addr bitmapinfoheader,sizeof BITMAPINFOHEADER,addr dwBytes,ebx
  mov eax,dwNumColors
	test eax,eax
	jz @f
	invoke WriteFile,hFile,addr colors,ColorSize,addr dwBytes,ebx
@@:
  mov eax,dwWidth
  xor edx,edx
  mov ecx,dwHeight
  mul ecx
  xor edx,edx
  mov ecx,dwBPP
  mul ecx
  shr eax,3
  mov ColorSize,eax

  invoke WriteFile,hFile,pBits,ColorSize,addr dwBytes,ebx
  invoke CloseHandle,hFile
  xor edi,edi
ExitFunc4:
;  invoke DeleteObject,hBitmap
ExitFunc3:
  invoke DeleteDC,memdc
ExitFunc2:
	invoke ReleaseDC,hWnd,hDc
ExitFunc:
	test edi,edi
	jz @f
  invoke MessageBox, ebx, edi, ebx, ebx
@@:
	mov eax,hBitmap
  ret
CapWindow endp

;####################################################################################################

EnCh proc hWnd:HWND,prm:DWORD
	invoke GetAncestor,hWnd,GA_ROOT
	.if eax==hWnd
		inc ntw
	.endif
	xor eax,eax
	inc eax
	inc nw
	mov ecx,hWnd
	cmp ecx,hwtr
	jnz @f
	mov edx,nw
	mov ncw,edx
@@:
	cmp ecx,hwt
	jnz @f
	mov edx,nw
	sub edx,ncw
	mov ncw,edx
	dec eax
@@:
	ret
EnCh endp

;######################################################################################################

InfoFromPoint proc uses ebx edi esi ptx:DWORD,pty:DWORD
	local buf[1024]:BYTE
	local buf1[MAX_PATH]:BYTE
	local buf2[MAX_PATH]:BYTE
	local rt:RECT
	local pt:POINT

	.if status==0
;		invoke WindowFromPoint,ptx,pty
		mov eax,ptx
		mov pt.x,eax
		mov eax,pty
		mov pt.y,eax
		invoke GetDesktopWindow
		mov ebx,eax
		mov esi,eax
		mov ecx,eax
@@:
		invoke MapWindowPoints,ecx,ebx,addr pt,1
;		invoke ChildWindowFromPointEx,ebx,pt.x,pt.y,CWP_SKIPINVISIBLE  ; CWP_ALL
		invoke RealChildWindowFromPoint,ebx,pt.x,pt.y
		test eax,eax
		jz @f
		cmp eax,ebx
		jz @f
		mov ecx,ebx
		mov ebx,eax
		jmp @b
@@:
		mov hwt,ebx
	.else
		mov eax,hwp
		mov hwt,eax
	.endif
	invoke GetClassName,hwt,addr buf1,MAX_PATH-1
	invoke SendMessage,hwt,WM_GETTEXT,MAX_PATH-1,addr buf2
	invoke GetWindowLong,hwt,GWL_ID
	mov ebx,eax

	invoke CreateRectRgn,0,0,0,0
	mov edi,eax
	invoke GetWindowRgn,hwt,edi
	push eax
	invoke DeleteObject,edi
	pop eax
	.if eax==0
		mov edi,offset _none
	.elseif eax==1
		mov edi,offset _null
	.elseif eax==2
		mov edi,offset _simple
	.elseif eax==3
		mov edi,offset _complex
	.else
		mov edi,offset DlgName
	.endif

	invoke GetWindowRect,hwt,addr rt
	invoke GetAncestor,hwt,GA_ROOT
	mov hwtr,eax

	xor eax,eax
	mov nw,eax
	mov ntw,eax
	mov ncw,eax
;	invoke GetDesktopWindow
;	invoke EnumChildWindows,eax,addr EnCh,0
	invoke EnumChildWindows,esi,addr EnCh,0

	invoke GetAncestor,hwt,GA_PARENT ; GA_ROOT ; GA_ROOTOWNER ; 
	mov hwta,eax
	mov eax,rt.left
	mov pt.x,eax
	mov eax,rt.top
	mov pt.y,eax
	invoke ScreenToClient,hwta,addr pt
	mov ecx,rt.right
	sub ecx,rt.left
	mov edx,rt.bottom
	sub edx,rt.top
	invoke wsprintf,addr buf,offset frmt,color,edi,hwt,ebx,ebx,ntw,ncw,nw,rt.left,rt.top,pt.x,pt.y,ecx,edx,addr buf1,addr buf2
	invoke lstrcmp,addr buff,addr buf
	.if eax!=0
		invoke lstrcpy,addr buff,addr buf
		invoke SendDlgItemMessage,hdlg,3000,WM_SETTEXT,0,addr buf
	.endif
	mov eax,hwt
	ret
InfoFromPoint endp

;######################################################################################################

PenProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local pt:POINT
	local rt:RECT
	local buf[MAX_PATH+1]:BYTE

	mov eax,uMsg

	.if eax==WM_CAPTURECHANGED && capt==1
		invoke SetCapture,hWnd
		invoke SetCursor,hcur_custom


	.elseif eax==WM_LBUTTONDBLCLK ;                                                           Snapshot / Bmp-file
		invoke ShowWindow,hw4001,SW_SHOWNORMAL
		invoke GetCursorPos,addr pt
		invoke SetWindowPos,hWnd,HWND_TOPMOST,pt.x,pt.y,0,0,SWP_NOSIZE OR SWP_NOACTIVATE
		dec pt.x
		invoke InfoFromPoint,pt.x,pt.y
		.if eax==hw2000
@exit0:
			invoke SendMessage,hdlg,WM_APP+100,0,0
			ret
		.elseif eax==hw2001 || eax==hw2002 || eax==hw2003
@exit:
			mov status,0
			invoke PostMessage,eax,BM_CLICK,0,0
			ret
		.endif

		invoke GetKeyState,VK_MENU ;                                                       ALT     choose root parent          
		and ax,8000h
		.if ax!=0
			mov eax,hwtr
		.else
			mov eax,hwt
		.endif
		mov hwp,eax

		invoke GetKeyState,VK_CONTROL ;                                                    CTRL    Bmp-file + Snapshot
		and ax,8000h
		.if ax!=0
			invoke GetTickCount
			invoke wsprintf,addr buf,addr frmt2,eax
			lea ebx,buf
			jmp @f
		.else ;                                                                                      Snapshot to old Static
			xor ebx,ebx
@@:
			invoke DeleteObject,hBtmp
;			invoke ShowWindow,hdlg,SW_HIDE
			invoke CapWindow,hwp,ebx
			mov hBtmp,eax
			invoke SendMessage,hw4001,STM_SETIMAGE,IMAGE_BITMAP,hBtmp
		.endif
		invoke SetWindowPos,hdlg,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE OR SWP_NOMOVE OR SWP_NOACTIVATE ;OR SWP_SHOWWINDOW

	.elseif eax==WM_RBUTTONDBLCLK ;                                                                 ColorPicker
		invoke DeleteObject,hbr
		invoke DeleteObject,hpen	
		invoke GetCursorPos,addr pt
		invoke SetWindowPos,hWnd,HWND_TOPMOST,pt.x,pt.y,0,0,SWP_NOSIZE OR SWP_NOACTIVATE
		dec pt.x
		invoke InfoFromPoint,pt.x,pt.y
		.if eax==hw2000
			jmp @exit0
		.elseif eax==hw2001 || eax==hw2002 || eax==hw2003
			jmp @exit
		.endif
		mov hwp,eax
		invoke GetWindowDC,hwp
		mov hdc,eax
		invoke GetWindowRect,hwp,addr rt
		mov eax,pt.x
		sub eax,rt.left
		mov ecx,pt.y
		sub ecx,rt.top
		invoke GetPixel,hdc,eax,ecx
		mov color,eax
		invoke CreateSolidBrush,color
		mov hbr,eax
		invoke CreatePen,PS_SOLID,10,color
		mov hpen,eax
		invoke ReleaseDC,hwp,hdc
		invoke InfoFromPoint,pt.x,pt.y
		invoke InvalidateRect,hw4000,0,1

	.elseif eax==WM_LBUTTONDOWN || eax==WM_RBUTTONDOWN ;                                             Pen || ?
		.if status==0
			mov ebx,eax
			invoke GetCursorPos,addr pt
			dec pt.x
			invoke InfoFromPoint,pt.x,pt.y
			.if eax==hw2000
				jmp @exit0
			.elseif eax==hw2001 || eax==hw2002 || eax==hw2003
				jmp @exit
			.endif
			mov hwp,eax

			invoke GetWindowRect,hwp,addr rt
			mov eax,pt.x
			sub eax,rt.left
			mov d_x,eax
			mov eax,pt.y
			sub eax,rt.top
			mov d_y,eax
			.if ebx==WM_LBUTTONDOWN
				invoke GetWindowDC,hwp
				mov hdc,eax
				invoke SelectObject,hdc,hpen
				mov hppen,eax
			.endif
			mov status,ebx
		.endif

	.elseif eax==WM_MOUSEMOVE
		invoke GetCursorPos,addr pt
		invoke SetWindowPos,hWnd,HWND_TOPMOST,pt.x,pt.y,0,0,SWP_NOSIZE OR SWP_NOACTIVATE
		dec pt.x
		.if status==WM_LBUTTONDOWN
			invoke GetCursorPos,addr pt
			invoke GetWindowRect,hwp,addr rt
			mov eax,rt.left
			sub pt.x,eax
			mov eax,rt.top
			sub pt.y,eax
			invoke SetPixel,hdc,pt.x,pt.y,0
			invoke MoveToEx,hdc,d_x,d_y,0
			invoke LineTo,hdc,pt.x,pt.y
			mov eax,pt.x
			mov d_x,eax
			mov eax,pt.y
			mov d_y,eax
		.endif
		invoke InfoFromPoint,pt.x,pt.y

	.elseif eax==WM_LBUTTONUP
		.if status==WM_LBUTTONDOWN
			invoke SelectObject,hdc,hppen
			invoke ReleaseDC,hwp,hdc
			mov status,0
		.endif

	.elseif eax==WM_RBUTTONUP
		.if status==WM_RBUTTONDOWN
			mov status,0
		.endif

	.endif
	invoke CallWindowProc,OldProc,hWnd,uMsg,wParam,lParam
	ret
PenProc endp

;######################################################################################################

;	BELLOW - ORIGINAL TEXT FROM  http://spiff.tripnet.se/~iczelion/files/Skin%20a%20Window.zip

;	MakeRegion PROC var_hDC:HDC,var_PicWidth:DWORD,var_PicHeight:DWORD
;
;	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	; MakeRegion returns a region that can be applied to (any) window of which you have the handle based on a bitmap you provide it with ;
;	; This bitmap needs to be passed to the routine in the form of a DC, also the width and height of the picture need to be specified   ;
;	; After this call the caller still needs to invoke SetWindowRgn to a window with this returned region itself, this routine only      ;
;	; returns the region so that this region itself can be used in further operations where needed.                                      ;
;	; The routine itself creates the final region by scanning the picture for lines of 1 pixel high to show, create a region from it and ;
;	; combining them to 1 final region                                                                                                   ;
;	; e.g. (T: transparant, N: non-transparant)                                                                                          ;
;	;	 suppose this is the first row of your image: TTTNNNNNNNTTTNN                                                                  ;
;	;	 This row will be translated into 2 regions: 1 region from col-positions 3 to 10                                               ;
;	;						     		   1 region from col-position 13 to the end of the row                               ; 
;	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	
;	LOCAL var_X:DWORD				; Col value
;	LOCAL var_Y:DWORD				; Row value
;	LOCAL var_StartLineX:DWORD		; start location of a region
;	LOCAL var_FullRegion:DWORD		; Combination of all Regions found so far
;	LOCAL var_LineRegion:DWORD		; Current region
;	LOCAL var_TransparantColor:DWORD	; color that is used to indicate transparancy
;	LOCAL var_InFirstRegion:DWORD		; First Region state 
;	LOCAL var_Inline:DWORD			; Inline Region state
;	
;	mov var_InFirstRegion,TRUE
;	mov var_Inline,FALSE
;	mov var_X,0
;	mov var_Y,0
;	mov var_StartLineX,0
;	
;	invoke GetPixel,var_hDC,0,0 ; Get the upper left pixel of the image to determine the color that the user intended to be transparant
;	mov var_TransparantColor,eax
;	
;	mov ebx, var_PicHeight
;		.WHILE var_Y < ebx ; Loop through all rows of the picture
;			mov ebx, var_PicWidth
;		
;			.WHILE var_X <= ebx ; Loop through the columns of each row
;	
;				invoke GetPixel,var_hDC,var_X,var_Y ; Get the pixel at current location
;				mov ebx, var_PicWidth
;				
;				; Check if the pixel==transparantcolor or if the routine has reached the end of the row
;				.IF eax==var_TransparantColor || var_X==ebx 
;	
;					; it did, now check wether we are creating a region or wether this is just another transparant pixel
;					; if it's another transparant pixel then just go to the next pixel, else create a region between the startpixel
;					; and the current found transparant or endrow pixel
;					
;					.IF var_Inline==TRUE 
;						mov var_Inline,FALSE
;						mov ebx,var_Y
;						inc ebx
;						invoke CreateRectRgn,var_StartLineX,var_Y,var_X,ebx
;						mov var_LineRegion,eax
;						.IF var_InFirstRegion==TRUE 
;							; if the region created is the first region created 
;							; then we don't have anything to combine it with yet
;	
;							push var_LineRegion
;							pop var_FullRegion
;							mov var_InFirstRegion,FALSE
;						.ELSE
;							; Combine the newly created region with the previously created regions 
;							; and store the final result in the Full_Region variable
;	
;							invoke CombineRgn,var_FullRegion,var_FullRegion,var_LineRegion,RGN_OR
;							invoke DeleteObject,var_LineRegion ; always clean up afterwards
;						.ENDIF
;					.ENDIF
;				.ELSE
;					; the pixel is neither transparant nor the end of the row nor are we currently in the creation of a line region
;					; so this pixel is the first pixel of a new line region to create
;					
;					.IF var_Inline==FALSE
;						mov var_Inline,TRUE ; make sure that the inline state is set to true 
;						push var_X
;						pop var_StartLineX ; set the startpixel to the current pixellocation
;					.ENDIF
;				.ENDIF
;				inc var_X ; increase the col location
;				mov ebx, var_PicWidth
;			.ENDW
;			inc var_Y ;increase the rowlocation
;			mov var_X,0 ;reset the col location
;			mov ebx, var_PicHeight
;		.ENDW
;	
;	mov eax, var_FullRegion ; return the final created region to the caller
;	ret
;	MakeRegion ENDP

;######################################################################################################

MakeRegion_M proc uses ebx edi esi hDC:HDC,Wdth:DWORD,Hght:DWORD,Color:DWORD

	local FullRegion:DWORD ; Combination of all Regions found so far
	local LineRegion:DWORD ; Current region
	local Inline:DWORD     ; Inline Region state
	local rt:RECT
	local ncolor:DWORD

	xor ebx,ebx            ; start location of a region
	xor edi,edi            ; X
	xor esi,esi            ; Y
	mov Inline,ebx
	mov FullRegion,ebx
	mov ncolor,ebx
	.while esi < Hght
		.while edi <= Wdth
			invoke GetPixel,hDC,edi,esi
			.if eax==Color
				mov ncolor,1
				jmp @f
			.elseif edi==Wdth
@@:
				.if Inline!=0
					mov Inline,0
					mov eax,esi
					inc eax
					invoke CreateRectRgn,ebx,esi,edi,eax
					.if FullRegion==0
						mov FullRegion,eax
					.else
						mov LineRegion,eax
						invoke CombineRgn,FullRegion,FullRegion,LineRegion,RGN_OR
						invoke DeleteObject,LineRegion
					.endif
				.endif
			.else
				.if Inline==0
					inc Inline
					mov ebx,edi
				.endif
			.endif
			inc edi
		.endw
		inc esi
		xor edi,edi
	.endw
	mov edx,ncolor
	mov eax,FullRegion
	ret
MakeRegion_M endp

;######################################################################################################

HoleProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local pt:POINT
	local rt:RECT

	mov eax,uMsg
	.if eax==WM_CAPTURECHANGED && capt==1
		invoke SetCapture,hWnd
		invoke SetCursor,hcur_custom

	.elseif eax==WM_LBUTTONDOWN || eax==WM_RBUTTONDOWN ;                                               Hole || ?
		.if status==0
			mov ebx,eax
			invoke GetCursorPos,addr pt
			dec pt.x
			invoke InfoFromPoint,pt.x,pt.y
			.if eax==hw2000
@exit0:
				invoke SendMessage,hdlg,WM_APP+100,0,0
				ret
			.elseif eax==hw2001 || eax==hw2003 || eax==hw2002
@exit:
				mov status,0
				invoke PostMessage,eax,BM_CLICK,0,0
				ret
			.endif
			invoke GetKeyState,VK_CONTROL
			and ax,8000h
			.if ax!=0
				mov eax,hwtr
			.else
				mov eax,hwt
			.endif
			mov hwp,eax
			mov status,ebx
		.endif

	.elseif eax==WM_MOUSEMOVE
		invoke GetCursorPos,addr pt
		invoke SetWindowPos,hWnd,HWND_TOPMOST,pt.x,pt.y,0,0,SWP_NOSIZE OR SWP_NOACTIVATE ;OR SWP_NOSENDCHANGING ;OR SWP_DEFERERASE ;; OR SWP_FRAMECHANGED
		dec pt.x
		.if status==WM_LBUTTONDOWN
			invoke GetWindowRect,hwp,addr rt
			mov eax,rt.left
			sub pt.x,eax
			mov eax,rt.top
			sub pt.y,eax
			invoke OffsetRgn,hr1,pt.x,pt.y
			invoke CreateRectRgn,0,0,0,0
			mov hr2,eax
			invoke GetWindowRgn,hwp,hr2
			.if eax==ERRORAPI
				mov eax,rt.left
				sub rt.right,eax
				mov eax,rt.top
				sub rt.bottom,eax
				invoke SetRectRgn,hr2,0,0,rt.right,rt.bottom
			.endif
			invoke CombineRgn,hr2,hr2,hr1,RGN_DIFF
			invoke SetWindowRgn,hwp,hr2,1
			xor eax,eax
			xor ecx,ecx
			sub eax,pt.x
			sub ecx,pt.y
			invoke OffsetRgn,hr1,eax,ecx
			invoke DeleteObject,hr2
		.else
			invoke InfoFromPoint,pt.x,pt.y
		.endif

	.elseif eax==WM_LBUTTONUP || eax==WM_RBUTTONUP
		.if status!=0
			mov status,0
;			invoke InvalidateRect,hdlg,0,1
		.endif

	.elseif eax==WM_LBUTTONDBLCLK || eax==WM_RBUTTONDBLCLK ;                                           Cancel All Holes || Hole from picked color
		invoke GetCursorPos,addr pt
		dec pt.x
		invoke InfoFromPoint,pt.x,pt.y
		.if eax==hw2000
			jmp @exit0
		.elseif eax==hw2001 || eax==hw2003 || eax==hw2002
			jmp @exit
		.endif
		invoke GetKeyState,VK_CONTROL
		and ax,8000h
		.if ax!=0
			mov eax,hwtr
		.else
			mov eax,hwt
		.endif
		mov hwp,eax

		.if uMsg==WM_RBUTTONDBLCLK
			.if eax==hw4000
				jmp @cwp
			.endif
			invoke GetWindowDC,hwp
			mov ebx,eax
			invoke GetWindowRect,hwp,addr rt
			mov eax,rt.left
			sub rt.right,eax
			mov eax,rt.top
			sub rt.bottom,eax
			invoke ShowWindow,hw4000,SW_HIDE
			invoke MakeRegion_M,ebx,rt.right,rt.bottom,color
			mov edi,eax
			.if edx!=0
				invoke CreateRectRgn,0,0,0,0
				mov hr2,eax
				invoke GetWindowRgn,hwp,hr2
				.if eax==ERRORAPI
					invoke SetRectRgn,hr2,0,0,rt.right,rt.bottom
				.endif
				invoke CombineRgn,hr2,hr2,edi,RGN_AND
				mov eax,hwp
				invoke SetWindowRgn,hwp,hr2,1	
				invoke DeleteObject,hr2
			.endif
			invoke DeleteObject,edi
			invoke ReleaseDC,hwp,ebx
			invoke ShowWindow,hw4000,SW_SHOWNORMAL

		.else  ; eax==WM_LBUTTONDBLCLK
			invoke SetWindowRgn,eax,0,1
		.endif

;	.endif
	.else
@cwp:
	invoke CallWindowProc,OldProc,hWnd,uMsg,wParam,lParam
	ret

	.endif
	xor eax,eax
	ret
HoleProc endp

;######################################################################################################

SizePosZord proc uses ebx edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local pt:POINT
	local rt:RECT
	local buf[MAX_PATH+1]:BYTE

	mov eax,uMsg
	.if eax==WM_CAPTURECHANGED && capt==1
		invoke SetCapture,hWnd
		invoke SetCursor,hcur_custom

	.elseif eax==WM_LBUTTONDOWN || eax==WM_RBUTTONDOWN ;                                             Pos || Size
		.if status==0
			mov ebx,eax
			invoke GetCursorPos,addr pt
			dec pt.x
			invoke InfoFromPoint,pt.x,pt.y
			.if eax==hw2000
@exit0:
				invoke SendMessage,hdlg,WM_APP+100,0,0
				ret
			.elseif eax==hw2001 || eax==hw2002 || eax==hw2003
@exit:
				mov status,0
				invoke PostMessage,eax,BM_CLICK,0,0
				ret
			.endif

			invoke GetKeyState,VK_MENU ;                                                                  ALT        choose root ancestor window
			and ax,8000h
			.if ax==0
				mov eax,hwt
				mov hwp,eax
				mov eax,hwta
				mov hwpa,eax
			.else
				mov eax,hwtr
				mov hwp,eax
				mov hwpa,0
			.endif

			invoke GetWindowRect,hwp,addr rt
			mov eax,pt.x
			sub eax,rt.left
			mov d_x,eax
			mov eax,pt.y
			sub eax,rt.top
			mov d_y,eax
    
			mov eax,pt.x
			mov d_x2,eax
			mov eax,pt.y
			mov d_y2,eax
			mov status,ebx

			.if ebx==WM_LBUTTONDOWN
				invoke GetKeyState,VK_ESCAPE ;                                                               ESC         close window
				and ax,8000h
				.if ax!=0
					mov eax,hwp
					.if eax!=hw4001
						invoke PostMessage,hwp,WM_CLOSE,0,0
						ret
					.endif
				.endif

				invoke GetKeyState,VK_CONTROL ;                                                               CTRL       click
				and ax,8000h
				.if ax!=0
					mov eax,pt.x
					mov ecx,pt.y
					and eax,0ffffh
					shl ecx,16
					add eax,ecx
					mov ebx,eax
					invoke ScreenToClient,hwp,addr pt
					mov eax,pt.x
					mov ecx,pt.y
					and eax,0ffffh
					shl ecx,16
					add eax,ecx
					mov edi,eax
					invoke DefWindowProc,hwp,WM_NCHITTEST,0,ebx
					.if eax==HTCLIENT
						invoke PostMessage,hwp,WM_LBUTTONDOWN,MK_LBUTTON,edi
						invoke Sleep,100
						invoke PostMessage,hwp,WM_LBUTTONUP,MK_LBUTTON,edi
					.else
						invoke PostMessage,hwp,WM_NCLBUTTONDOWN,eax,ebx
;						invoke PostMessage,hwp,WM_LBUTTONUP,0,edi
						invoke PostMessage,hwp,WM_LBUTTONUP,0,ebx
					.endif
				.endif

				invoke GetKeyState,VK_SHIFT	;                                                              SHIFT      if STATIC: on/off SS_CENTERIMAGE
				and ax,8000h
				.if ax!=0
					invoke RealGetWindowClass,hwp,addr buf,MAX_PATH
					invoke lstrcmpi,addr buf,addr _static
					.if eax==0
						invoke GetWindowLong,hwp,GWL_STYLE
						mov ecx,eax
						mov edx,SS_CENTERIMAGE
						and eax,edx
						.if eax==edx
							not edx
							and ecx,edx
						.else
							or ecx,edx
						.endif
						invoke SetWindowLong,hwp,GWL_STYLE,ecx
						invoke SetWindowPos,hwp,0,0,0,0,0,SWP_NOZORDER OR SWP_NOSIZE OR SWP_NOMOVE OR SWP_FRAMECHANGED OR SWP_NOACTIVATE
					.endif
				.endif
			.endif
		.endif

	.elseif eax==WM_MOUSEMOVE
		invoke GetCursorPos,addr pt
		invoke SetWindowPos,hWnd,HWND_TOPMOST,pt.x,pt.y,0,0,SWP_NOSIZE OR SWP_NOACTIVATE
		dec pt.x

		.if status==WM_LBUTTONDOWN ; Pos
			invoke ScreenToClient,hwpa,addr pt
			mov eax,pt.x
			sub eax,d_x
			mov ecx,pt.y
			sub ecx,d_y
			invoke SetWindowPos,hwp,0,eax,ecx,0,0,SWP_NOZORDER OR SWP_NOSIZE OR SWP_NOACTIVATE

		.elseif status==WM_RBUTTONDOWN ; Size
;			invoke GetKeyState,VK_CONTROL	;                                                                  CTRL       if STATIC: delete SS_CENTERIMAGE
;			and ax,8000h
;			.if ax!=0
;				invoke RealGetWindowClass,hwp,addr buf,MAX_PATH
;				invoke lstrcmpi,addr buf,addr _static
;				.if eax==0
;					invoke GetWindowLong,hwp,GWL_STYLE
;					and eax,not SS_CENTERIMAGE
;					invoke SetWindowLong,hwp,GWL_STYLE,eax
;				.endif
;			.endif
			invoke GetWindowRect,hwp,addr rt
			mov eax,rt.right
			sub eax,rt.left
			mov edx,pt.x
			add eax,edx
			sub eax,d_x2
			mov d_x2,edx
			mov ecx,rt.bottom
			sub ecx,rt.top
			mov edx,pt.y
			add ecx,edx
			sub ecx,d_y2
			mov d_y2,edx
			invoke SetWindowPos,hwp,0,0,0,eax,ecx,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOACTIVATE
			invoke InvalidateRect,hwp,0,1
			invoke UpdateWindow,hwp
		.endif
		invoke InfoFromPoint,pt.x,pt.y

	.elseif eax==WM_LBUTTONUP	; end
		.if status!=0
			mov status,0
		.endif

	.elseif eax==WM_RBUTTONUP	; end
		.if status!=0
			mov status,0
			invoke InvalidateRect,hwtr,0,1
;			invoke UpdateWindow,hwtr
		.endif

	.elseif eax==WM_LBUTTONDBLCLK || eax==WM_RBUTTONDBLCLK || eax==WM_MOUSEWHEEL
		invoke GetKeyState,VK_F5 ;                                                                            F5         set parent = Progman
		and ax,8000h
		.if ax!=0 && uMsg==WM_LBUTTONDBLCLK
			mov eax,hProgman
;			invoke GetWindow,hProgman,GW_CHILD                                                                  F5         set parent = SysListView32 (Progman's)
;			invoke GetWindow,eax,GW_CHILD
			invoke SetParent,hwp,eax
			mov hw_old,eax
			ret
		.endif
		invoke GetKeyState,VK_F7 ;                                                                            F6         set parent = 0
		and ax,8000h
		.if ax!=0 && uMsg==WM_LBUTTONDBLCLK
			invoke SetParent,hwp,0
			mov hw_old,eax
			ret
		.endif
		invoke GetKeyState,VK_F6 ;                                                                            F6         set parent = 0
		and ax,8000h
		.if ax!=0 && uMsg==WM_LBUTTONDBLCLK
			invoke SetParent,hwp,hw_old
			ret
		.endif
		invoke GetCursorPos,addr pt
		dec pt.x
		invoke InfoFromPoint,pt.x,pt.y
		.if eax==hw2000
			jmp @exit0
		.elseif eax==hw2001 || eax==hw2002 || eax==hw2003
			jmp @exit
		.endif
		.if uMsg==WM_RBUTTONDBLCLK || (uMsg==WM_MOUSEWHEEL && wParam<80000000h) ;                              z-down
			invoke GetWindow,hwt,GW_HWNDNEXT
		.else ; uMsg==WM_LBUTTONDBLCLK || (uMsg==WM_MOUSEWHEEL && wParam>80000000h) ;                          z-up
			mov ebx,hwt
@@:
			invoke GetWindow,ebx,GW_HWNDPREV
			mov ebx,eax
			invoke GetAncestor,ebx,GA_ROOTOWNER
			cmp eax,hwt
			jz @b
			invoke GetWindow,ebx,GW_HWNDPREV
		.endif						
		invoke SetWindowPos,hwt,eax,0,0,0,0,SWP_NOSIZE OR SWP_NOMOVE OR SWP_FRAMECHANGED OR SWP_NOACTIVATE

	.endif
	invoke CallWindowProc,OldProc,hWnd,uMsg,wParam,lParam
	ret
SizePosZord endp

;######################################################################################################

DlgProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local pt:POINT
	local rt:RECT
	local buf[MAX_PATH+1]:BYTE

	mov eax,uMsg

	.if eax==WM_CLOSE
    invoke KillTimer,hWnd,100
		invoke DeleteObject,hBtmp
		invoke DeleteObject,hbrbg
;		invoke DeleteObject,hrgnframe
		invoke DeleteObject,hpen
		invoke DeleteObject,hbr3000
		invoke DeleteObject,hbr
		invoke DeleteObject,hr1
		invoke EndDialog,hWnd,0

  .elseif eax==WM_TIMER
    invoke GetWindowRect,hw2000,addr rt
    invoke GetCursorPos,addr pt
    invoke PtInRect,addr rt,pt.x,pt.y
    mov ebx,eax
    invoke IsDlgButtonChecked,hWnd,2000
    .if eax==BST_UNCHECKED && ebx!=0
      .if timercount>4
        invoke SendMessage,hWnd,WM_COMMAND,2000,hw2000
      .else 
        inc timercount
        jmp @f
      .endif
    .endif
    mov timercount,0
@@:

	.elseif eax==WM_INITDIALOG
		invoke GetDesktopWindow
		mov ebx,eax
		invoke GetClientRect,ebx,addr rt
		mov ebx,rt.right
		invoke GetWindowRect,hWnd,addr rt
		sub ebx,rt.right
		add ebx,rt.left
		invoke SetWindowPos,hWnd,0,ebx,50,0,0,SWP_NOZORDER OR SWP_NOSIZE OR SWP_NOACTIVATE OR SWP_FRAMECHANGED
		mov eax,hWnd
		mov hdlg,eax
		invoke GetDlgItem,hWnd,2000
		mov hw2000,eax
		invoke GetDlgItem,hWnd,2001
		mov hw2001,eax
		invoke GetDlgItem,hWnd,2003
		mov hw2003,eax
		invoke GetDlgItem,hWnd,2002
		mov hw2002,eax
		invoke GetDlgItem,hWnd,3000
		mov hw3000,eax
		invoke GetDlgItem,hWnd,4000
		mov hw4000,eax
		invoke CreateWindowEx,WS_EX_TOPMOST or WS_EX_TOOLWINDOW or WS_EX_ACCEPTFILES,\; or WS_EX_LAYERED,\
													offset _static,offset _snap,\
													WS_POPUP or SS_BITMAP or SS_NOTIFY,\
													0,0,0,0,0,0,hinst,0
		mov hw4001,eax
		invoke SetWindowLong,hw4001,GWL_WNDPROC,addr NewProc
		mov oldproc,eax
		invoke GetClassLong,hw4001,GCL_STYLE
		and eax,not CS_PARENTDC
		invoke SetClassLong,hw4001,GCL_STYLE,eax
;		invoke SetLayeredWindowAttributes,hw4001,0,255,LWA_ALPHA

		invoke LoadCursor,0,IDC_HAND
		invoke SetClassLong,hWnd,GCL_HCURSOR,eax
		invoke GetSystemMenu,hWnd,0
		mov hmenu,eax
		invoke AppendMenu,hmenu,MF_SEPARATOR,0,0
		invoke AppendMenu,hmenu,MF_STRING,idm_about,addr _about
		invoke LoadCursor,hinst,500
		mov hcur_custom,eax

    invoke SetWindowLong,hw2000,GWL_STYLE,WS_VISIBLE or WS_CHILD or WS_CLIPSIBLINGS or WS_TABSTOP or BS_AUTOCHECKBOX or BS_PUSHLIKE or BS_ICON
		invoke SetWindowPos,hw2000,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
		invoke SendMessage,hw2000,BM_SETIMAGE,IMAGE_ICON,hcur_custom

		invoke SendMessage,hw2001,BM_CLICK,0,0
		mov eax,offset SizePosZord
		mov lpproc,eax
		invoke CreateSolidBrush,color3000
		mov hbr3000,eax
		invoke CreateSolidBrush,color
		mov hbr,eax
		invoke CreatePen,PS_SOLID,10,color
		mov hpen,eax
		invoke CreateEllipticRgn,-8,-8,8,8
		mov hr1,eax
		invoke GetCursorPos,addr pt
		invoke CreateWindowEx,WS_EX_TOPMOST or WS_EX_TOOLWINDOW or WS_EX_NOACTIVATE,\ ;  or WS_EX_LAYERED
													addr _static,addr _cursor,\
													WS_POPUP OR SS_NOTIFY,\ ; or WS_CAPTION  or WS_VISIBLE  or WS_SYSMENU
													pt.x,pt.y,1,1,0,0,hinst,0
		mov hw0,eax
;		invoke SetLayeredWindowAttributes,hw0,0,1,LWA_ALPHA
		invoke SetWindowLong,hw0,GWL_WNDPROC,lpproc
		mov OldProc,eax
;		invoke CreateWindowEx,WS_EX_TOPMOST or WS_EX_TOOLWINDOW,\
;													offset _32770,offset _frame,\
;													WS_POPUP or WS_CLIPSIBLINGS or WS_VISIBLE,\
;													0,0,0,0,0,0,hinst,0                             ; 0,0,0,0,hWnd,0,hinst,0
;		mov hframe,eax
;		invoke SetWindowLong,hframe,GWL_WNDPROC,addr New32770
;		mov old32770,eax
;		invoke GetStockObject,BLACK_BRUSH
;		mov hbrframe,eax
;		invoke CreateRectRgn,0,0,0,0
;		mov hrgnframe,eax

    invoke SetTimer,hWnd,100,500,0

		invoke FindWindow,addr _Progman,0
		mov hProgman,eax
		jmp @f

	.elseif eax==WM_LBUTTONDBLCLK
		invoke DeleteObject,hbrbg
@@:
		invoke LoadBitmapBG,hWnd,hinst,600,LR_DEFAULTCOLOR,1
		mov hbrbg,eax
		invoke RedrawWindow,hWnd,0,0,RDW_ERASE or RDW_INVALIDATE or RDW_ALLCHILDREN

	.elseif eax==WM_CTLCOLORDLG
		mov eax,hbrbg
		ret

	.elseif eax==WM_CTLCOLORSTATIC
		mov eax,lParam
		.if eax==hw4000
			invoke SetBkColor,wParam,color
			mov eax,hbr
		.elseif eax==hw3000
			invoke SetBkColor,wParam,color3000
			mov eax,hbr3000
		.endif
		ret

	.elseif eax==WM_ACTIVATE
		invoke IsWindowVisible,hw0
		.if eax!=0
			invoke SetForegroundWindow,hw0
			invoke SetCapture,hw0
			
			invoke InvalidateRect,hw2000,0,1
			
			invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOSIZE OR SWP_NOMOVE OR SWP_NOACTIVATE OR SWP_FRAMECHANGED
			invoke SetCursor,hcur_custom
		.endif

;	.elseif eax==WM_SETCURSOR
;		invoke IsWindowVisible,hw0
;		.if eax!=0
;			invoke SetCapture,hw0
;;		invoke SetCursor,hcur_custom
;		.endif

	.elseif eax==WM_COMMAND
		.if wParam==2000
			invoke IsWindowVisible,hw0
			.if eax==0
				xor eax,eax
				mov status,eax
				mov hwt,eax
				mov hwp,eax
				mov byte ptr [buff],al

				invoke SendMessage,hw2000,BM_SETIMAGE,IMAGE_ICON,0
				invoke SetWindowLong,hw2000,GWL_STYLE,WS_CLIPSIBLINGS or WS_CHILD or WS_VISIBLE or WS_TABSTOP or BS_AUTOCHECKBOX or BS_PUSHLIKE or BS_MULTILINE
				invoke SetWindowPos,hw2000,0,0,0,0,0,SWP_NOZORDER or SWP_NOSIZE or SWP_NOMOVE or SWP_FRAMECHANGED or SWP_NOACTIVATE
    		invoke SendMessage,hw2000,WM_SETTEXT,0,addr _btntext

				invoke SetWindowLong,hw0,GWL_WNDPROC,lpproc
				invoke ShowWindow,hw0,SW_SHOWNORMAL

				invoke SetCapture,hw0
				invoke SetCursor,hcur_custom
				mov hcur_sys,eax
				mov capt,1
			.endif
		.elseif wParam==2001
			mov eax,offset SizePosZord
			jmp @f
		.elseif wParam==2002
			mov eax,offset HoleProc
			jmp @f
		.elseif wParam==2003
			mov eax,offset PenProc
@@:
			mov lpproc,eax
			invoke SetWindowLong,hw0,GWL_WNDPROC,lpproc
		.endif

	.elseif eax==WM_APP+100
		mov status,0
		mov capt,0
		invoke ReleaseCapture
		invoke ShowWindow,hw0,SW_HIDE

		invoke SetWindowLong,hw2000,GWL_STYLE,WS_CHILD or WS_VISIBLE or WS_TABSTOP or WS_CLIPSIBLINGS or BS_AUTOCHECKBOX or BS_PUSHLIKE or BS_ICON
		invoke SetWindowPos,hw2000,0,0,0,0,0,SWP_NOZORDER or SWP_NOSIZE or SWP_NOMOVE or SWP_FRAMECHANGED or SWP_NOACTIVATE
		invoke SendMessage,hw2000,BM_SETIMAGE,IMAGE_ICON,hcur_custom

		invoke SetCursor,hcur_sys

	.elseif eax==WM_SYSCOMMAND && wParam==idm_about
		invoke MessageBox,hWnd,offset _about2,offset _about,40000h	; hWnd/0


	.elseif	eax==WM_DROPFILES
		invoke ShowWindow,hw4001,SW_SHOWNORMAL
		invoke DragQueryFile,wParam,0,addr buf,MAX_PATH
		invoke DragFinish,wParam
		invoke LoadImage,0,addr buf,IMAGE_BITMAP,0,0,LR_LOADFROMFILE
		.if eax!=0
			push eax
			invoke DeleteObject,hBtmp
			pop hBtmp
			invoke SendMessage,hw4001,STM_SETIMAGE,IMAGE_BITMAP,hBtmp
		.endif

;	.elseif	eax==WM_NCPAINT || eax==WM_NCACTIVATE
;		invoke DefWindowProc,hWnd,eax,wParam,lParam
;		invoke GetWindowDC,hWnd
;		mov ebx,eax
;		mov rt.left,200
;		mov rt.top,5
;		mov  rt.right,217
;		mov rt.bottom,19
;		invoke DrawFrameControl,ebx,addr rt,DFC_CAPTION,DFCS_CAPTIONHELP
;		invoke ReleaseDC,hWnd,ebx

	.else
		xor eax,eax
		ret
	.endif
	xor eax,eax
	inc eax
	ret
DlgProc endp

;######################################################################################################

start:
	invoke GetModuleHandle,0
	mov hinst,eax	
	invoke DialogBoxParam,eax,offset DlgName,0,offset DlgProc,0
	invoke ExitProcess,eax
	invoke InitCommonControls
end start

;######################################################################################################
